#[derive(Debug)]
struct Rectangle {
    width: u32,
    height: u32,
}

impl Rectangle {
    fn area(&self) -> u32 {
        self.width * self.height
    }
    fn can_hold(&self, r2: &Rectangle) -> bool {
        self.width > r2.width && self.height > r2.height
    }
}

impl Rectangle {
    fn square(size: u32) -> Self {
        Self {
            width: size,
            height: size,
        }
    }
}




// MAIN
fn main() {
    let rect1 = Rectangle { width:30, height:50};
    let rect2 = Rectangle { width:10, height:40};
    let rect3 = Rectangle { width:60, height:45};

    println!("r: {}", rect1.area());
    println!("r: {}", rect2.area());
    println!("r: {}", rect3.area());

    println!("Can rect1 hold rect2? {}", rect1.can_hold(&rect2));
    println!("Can rect1 hold rect3? {}", rect1.can_hold(&rect3));

    let sq = Rectangle::square(5);
    println!("r: {:?}", sq);

}

